Loading...
Searching...
No Matches
Sip_server

## Macros

#define | sip_server(sip)
| Access a SIP Server header structure sip_server_t from sip_t.
#define | SIP_SERVER_INIT()
| Initializer for structure sip_server_t.
#define | SIPTAG_SERVER(x)
| Tag list item for pointer to a Server header structure sip_server_t.
#define | SIPTAG_SERVER_REF(x)
| Tag list item for reference to a Server header pointer.
#define | SIPTAG_SERVER_STR(s)
| Tag list item for string with Server header value.
#define | SIPTAG_SERVER_STR_REF(x)
| Tag list item for reference to a Server header string.

## Typedefs

typedef struct msg_generic_s | sip_server_t
| @

## Functions

issize_t | sip_server_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Server header.
issize_t | sip_server_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Server header.
sip_server_t * | sip_server_init (sip_server_t x[1])
| Initialize a structure sip_server_t.
int | sip_is_server (sip_header_t const *header)
| Test if header object is instance of sip_server_t.
sip_server_t * | sip_server_dup (su_home_t *home, sip_server_t const *hdr))
| Duplicate a list of Server header header structures sip_server_t.
sip_server_t * | sip_server_copy (su_home_t *home, sip_server_t const *hdr))
| Copy a list of Server header header structures sip_server_t.
sip_server_t * | sip_server_make (su_home_t *home, char const *s))
| Make a Server header structure sip_server_t.
sip_server_t * | sip_server_format (su_home_t *home, char const *fmt,...)))
| Make a Server header from formatting result.

## Variables

msg_hclass_t | sip_server_class []
| Header class for Server header.
tag_typedef_t | siptag_server
| Tag for Server header object.
tag_typedef_t | siptag_server_str
| Tag for string with Server header value.

## Detailed Description

## Macro Definition Documentation

## SIP_SERVER_INIT

#define SIP_SERVER_INIT | ( |  | ) |

Initializer for structure sip_server_t.

A static sip_server_t structure for Server header must be initialized with the SIP_SERVER_INIT() macro. For instance,

sip_server_t sip_server = SIP_SERVER_INIT;
SIP_SERVER_INIT
#define SIP_SERVER_INIT()
Initializer for structure sip_server_t.
Definition sip_protos.h:6336
sip_server
#define sip_server(sip)
Access a SIP Server header structure sip_server_t from sip_t.
Definition sip_protos.h:6319
sip_server_t
struct msg_generic_s sip_server_t
@
Definition sip.h:189

## SIPTAG_SERVER

#define SIPTAG_SERVER | ( |  | x | ) |

Tag list item for pointer to a Server header structure sip_server_t.

The SIPTAG_SERVER() macro is used to include a tag item with a pointer to a sip_server_t structure in a tag list.

Parameters

  x | pointer to a sip_server_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SERVER_REF().

## SIPTAG_SERVER_STR

#define SIPTAG_SERVER_STR | ( |  | s | ) |

Tag list item for string with Server header value.

The SIPTAG_SERVER_STR() macro is used to include a tag item with a string containing value of a sip_server_t header in a tag list.

Parameters

  s | pointer to a string containing Server header value, or NULL.

The string in SIPTAG_SERVER_STR() can be converted to a sip_server_t header structure by giving the string s has second argument to function sip_server_make().

The corresponding tag taking reference parameter is SIPTAG_SERVER_STR_REF().

## Typedef Documentation

## sip_server_t

typedef struct msg_generic_s sip_server_t

@

The Server response-header field contains information about the software used by the user agent server to handle the request. Its syntax is defined in RFC 2616 section 14.38 and RFC 3261 as follows:

Server = "Server" HCOLON server-val *(LWS server-val)
server-val = product / comment
product = token [SLASH product-version]
product-version = token
LWS
#define LWS

The parsed Server header is stored in sip_server_t structure.

The structure sip_server_t contains representation of a SIP Server header.

The sip_server_t is defined as follows:

typedef struct msg_generic_s
{
msg_common_t g_common[1]; // Common fragment info
msg_generic_t *g_next; // Link to next header
char const *g_string; // Server tokens
} sip_server_t;
msg_common_t
struct msg_common_s msg_common_t
msg_generic_s
msg_generic_s::g_common
msg_common_t g_common[1]
msg_generic_s::g_string
char const * g_string
msg_generic_s::g_next
msg_generic_t * g_next

## Function Documentation

## sip_is_server()

int sip_is_server | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_server_t.

Check if the header class is an instance of Server header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header server
  0 | (false) otherwise

## sip_server_copy()

sip_server_t * sip_server_copy | ( | su_home_t * | home,
|  | sip_server_t const * | hdr )

inline

Copy a list of Server header header structures sip_server_t.

The function sip_server_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  server = sip_server_copy(home, sip->sip_server);
  sip_server_copy
  sip_server_t * sip_server_copy(su_home_t *home, sip_server_t const *hdr))
  Copy a list of Server header header structures sip_server_t.
  Definition sip_protos.h:6466

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_server_dup()

sip_server_t * sip_server_dup | ( | su_home_t * | home,
|  | sip_server_t const * | hdr )

inline

Duplicate a list of Server header header structures sip_server_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  server = sip_server_dup(home, sip->sip_server);
  sip_server_dup
  sip_server_t * sip_server_dup(su_home_t *home, sip_server_t const *hdr))
  Duplicate a list of Server header header structures sip_server_t.
  Definition sip_protos.h:6423

Returns
  A pointer to the newly duplicated sip_server_t header structure, or NULL upon an error.

## sip_server_format()

sip_server_t * sip_server_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Server header from formatting result.

Make a new sip_server_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_server_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_server_init()

sip_server_t * sip_server_init | ( | sip_server_t | x[1] | ) |

inline

Initialize a structure sip_server_t.

An sip_server_t structure for Server header can be initialized with the sip_server_init() function/macro. For instance,

sip_server_t sip_server;
sip_server_init(&sip_server);
sip_server_init
sip_server_t * sip_server_init(sip_server_t x[1])
Initialize a structure sip_server_t.
Definition sip_protos.h:6354

## sip_server_make()

sip_server_t * sip_server_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Server header structure sip_server_t.

The function sip_server_make() makes a new sip_server_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_server_t header structure, or NULL upon an error.

## Variable Documentation

## sip_server_class

msg_hclass_t sip_server_class[]

extern

Header class for Server header.

The header class sip_server_class defines how a SIP Server header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_server_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.